///////////////////////////////////////////////
//  t\Cu@for PIC18Fxxxx
//  ȉ̋@\
//    LCD_int()     ----- 
//    LCD_cmd(cmd)  ----- R}ho
//    LCD_dat(chr)  ----- P\
//    LCD_str(*char) ---- \
//    LCD_ROMstr(*str) -- ROM\
//    LCD_posyx(y,x) ---- J[\ʒuwAs yAʒu x
//    LCD_clr()     ----- S
//    LCD_hex(chr)  ----- PUiϊ\
//////////////////////////////////////////////
#include <p18cxxx.h>
#include <delays.h>
#include "L_LCD.h"

//-------- ʂSrbgf[^o (Lower nibbleڑ) 
void LCD_out(char c){
    LCD_DB = (c>>4) | (LCD_DB & 0xF0);
    LCD_EN = 1;          // Enable Hi
    Delay1TCY();         // NOP
    LCD_EN = 0;          // Enable Low
}
//-------- P\
void LCD_dat(char c){
    LCD_RS = 1;          // \f[^̑M    
    LCD_out(c);          // ʂSrbgo
    LCD_out(c<<4);       // ʂSrbgo
    Delay_50uS;          // 50sec
}
//-------- R}ho
void LCD_cmd(char c){
    LCD_RS = 0;          // R}hf[^̑M
    LCD_out(c);          // ʂSrbgo
    LCD_out(c<<4);       // ʂSrbgo
    if(c & 0xFC)         // ʂUrbgɂP閽
        Delay_50uS;      // 50usec
    else
        Delay_2mS;       // 2msec@ClearHomeR}h
}
//-------- S
void LCD_clr(void){
    LCD_cmd(0x01);       //ClearR}ho
}
//-------- J[\ʒuw
void LCD_posyx(char ypos, char xpos){
    unsigned char pcode;
    switch(ypos & 0x03){    
        case 0:    pcode=0x80;break;
        case 1:    pcode=0xC0;break;
        case 2:    pcode=0x94;break;
        case 3:    pcode=0xD4;break;
    }
    LCD_cmd(pcode += xpos);
}
//-------- o
void LCD_str(char *str){
    while(*str)            //̏I(00)܂Ōp
        LCD_dat(*str++);   //o͂|C^{P
}
//-------- Rom o
void LCD_ROMstr(rom const char *str){
    while(*str)            //̏I(00)܂Ōp
        LCD_dat(*str++);   //o͂|C^{P
}
//-------- PUiϊ\
void LCD_hex(char c){
    LCD_hxH(c);
    LCD_hxL(c);
}
//****************************************************************
//  LCD_hxL(char) ̉ʂSrbĝPUi\
//  LCD_hxH(char) ̏ʂSrbĝPUi\
//****************************************************************
char LCD_hxL(char c){
    c = c & 0x0F;            // ʂSrbgo
    if(c < 10){              // 9ȉȂ
        c += 0x30;           //   '0'̕R[h
    }else{                   // 10ȏȂ
        c += (0x41-10);      //   (c-10)
    }                        //   'A'̕R[h
    LCD_dat(c);
}
char LCD_hxH(char c){        // ʂSrbgʂɈړ
    return LCD_hxL(c >> 4);  // ʂ̂PUiԂ
}
//-------- 
void LCD_int(void){
    Delay_20mS;               //20msec
    LCD_RS = 0;               //R}h̑M
    LCD_out(0x30);Delay_5mS;  // 8bit mode set//5msec
    LCD_out(0x30);Delay_1mS;  // 8bit mode set
    LCD_out(0x30);Delay_1mS;  // 8bit mode set
    LCD_out(0x20);Delay_1mS;  // 4bit mode set
    LCD_cmd(0x2E);            // DL=0 (4bit mode)
    LCD_cmd(0x08);            // Display off
    LCD_cmd(0x0C);            // Display on Cursor=1 Blink=0
    LCD_cmd(0x06);            // Entry Inc/Dec=1 Shift=0
    LCD_cmd(0x01);            // Clear
}
