//***************************************************************
//    PIC18F14K50  <<< HID Bootloader >>>
//    ԊOR͂LCDɕ\ 2011/10/12 org
//     1)Define I/O PORT
//         PORTA(3)pin 4    :  PushSW
//         PORTB(4)pin 13   :  LED
//         PORTC(0-3)       :  LCD_(DB4-7)
//         PORTC(4)pin 6    :  LCD_(EN)
//         PORTC(5)pin 5    :  LCD_(RS)
//         PORTC(6)pin 8    :  IR
//     2)OSC
//         48MHz (12MHz Xtalj
//***************************************************************
//    2011/12/12 Rev1 PushSw̃`^Oh~fBǉ
//***************************************************************

#include <p18f14k50.h>
#include <delays.h>
#include <timers.h>
#include "L_LCD.h"      //LCD֐

#define T0IF        INTCONbits.TMR0IF
#define IrIN        PORTCbits.RC6
#define PushSW      PORTAbits.RA3
#define LED         PORTBbits.RB4
#define maxBits     80
//------------ Zbg xNg̈ړ-----------------------
#define REMAPPED_RESET_VECTOR_ADDRESS    0x1000
extern void _startup (void);
#pragma code reset_vect = REMAPPED_RESET_VECTOR_ADDRESS
void _reset (void){_asm goto _startup _endasm}
//------------------------------------------------------------

// ----- ֐vg^CsO -----
void ito_st(unsigned long, char *,char);
void LCD_dec(char);
char ck_SW();

#pragma code
//****** C  **************************************
void main(void){
    char msg[] ="--,---uS";
    char numBits;
    char i;
    char theByte;
    unsigned int period;
    unsigned int startMark;
    unsigned int startSpace;
    overlay unsigned char markBits[maxBits];
    overlay unsigned char spaceBits[maxBits];
    PORTA = 0x00;
    PORTB = 0x00;
    PORTC = 0x00;
    TRISA = 0b11111111;   //PortA ׂē
    TRISB = 0b11101111;   //PortB RB4o
    TRISC = 0b11000000;   //PortC RC0-5o
    ANSEL  = 0;           //ׂăfW^
    ANSELH = 0;

    LCD_int();                            // LCD
    OpenTimer0(                           // Timer0
        TIMER_INT_OFF &                   //   PS1/128łPJEg
        T0_16BIT &                        //   1/(12M/128)=10.66Sec
        T0_SOURCE_INT &                   //   JEgAbv699mSec
        T0_PS_1_128 );                    //       i10.66x65536j
    while(1){       // --- JԂ ---
    LCD_clr();
    LCD_ROMstr("  IR Analyzer");          // LCDReadyʂ̕\
    LCD_posyx(1,3);
    LCD_ROMstr("- Ready -");
    Delay10KTCYx(120);
// ------- Start Bit i[_[j̑ ------------------------
    while(1){
        while(IrIN);                      // MarkM ҂
        WriteTimer0(0);                   // -- MarkԑJn
        while(!IrIN);                     // Mark̏I҂
        period = ReadTimer0();            // MarkԎ擾
        WriteTimer0(0);                   // -- SpaceԑJn
        startMark = period*10.6;          // MarkԂSecɕϊۑ
        if(startMark < 2000) continue;    // 2mS̓mCYȂ̂ł蒼
        while(IrIN);                      // SpacȅI҂
        period = ReadTimer0();            // SpaceԎ擾
        WriteTimer0(0);                   // -- MarkԑJn
        startSpace = period*10.6;         // SpaceԂSecɕϊۑ
        if(startMark > startSpace) break; // MarkSpace蒷ȂOK
    }
// ------- DataBit̑ ------------------------------------------
	LED = 1;                              // LED ON
    for(i = 0; i < maxBits; i++){
        while(IrIN == 0);                 // Mark̏I҂
        markBits[i] = TMR0L;              // Markԕۑ
        WriteTimer0(0);                   // -- SpaceԑJn
        while(IrIN && TMR0L < 250);       // Spac̏I҂
        spaceBits[i] = TMR0L;             // Spaceԕۑ
        WriteTimer0(0);                   // -- Mark ԑJn
        if(spaceBits[i]>= 250) break;     // SpaceԂ2.7mSȏȂI
    }
    numBits=i;                            // 擾f[^Bitۑ
	LED = 0;                              // LED OFF
// ------- R[h̕ނƎMrbg̕\ ------------
    LCD_clr();                            // StartBitSpace̒ŕ
    if(startSpace < 1000){                // 1mSȉSONY
        LCD_ROMstr("SONY format");        //   SONYStopBit
        spaceBits[numBits] = 50;          //   f[^ŏIĂ邽
        numBits += 1;                     //   擾f[^𒲐
    }
    else if(startSpace < 3000)            // 3mSȉ͉Ɠdi
        LCD_ROMstr("AEHA format");        //
    else                                  // NEC
        LCD_ROMstr("NEC format");         //
    LCD_posyx(0, 14);                     // MBit\
    LCD_dec(numBits); 
// ------- MR[hHex\ ------------------------
    LCD_posyx(1, 0);
    theByte = 0;
    for(i = 0; i < numBits; i++){              // MBitJ
        theByte >>= 1;
        if((markBits[i] + spaceBits[i]) > 127) // Mrbg̍v
            theByte += 0x80;                   // u1vuOv𔻒f
        if((i%8)== 7){                         // PByte
            LCD_hex(theByte);                  // HEXŕ\
            theByte = 0;
        }
    }
    if((i%8)!= 0){                      // PBytei8bitj̎c
        LCD_hex(theByte);               // HEXŕ\
    }
    if(ck_SW())continue;                // SWŎIRM
// +++++++ ȉ͏ڍ׎Ԃ̕\ +++++++
// ------- Start Bit i[_[j̕\
    LCD_posyx(0,0);                     // iɃJ[\ړ
    LCD_ROMstr("Start bit     ");       //    ^Cg\
    LCD_posyx(0, 14);                   //    E[ɃJ[\ړ
    LCD_dec(numBits);                   //    MBit\
    LCD_posyx(1,0);                     // iɈړ
    ito_st(startMark, msg, 6);          //    MarkԂ𕶎ϊ
    LCD_str(msg);                       //    \
    LCD_posyx(1,8);                     //    Ɉړ
    ito_st(startSpace, msg, 6);         //    SpaceԂ𕶎ϊ
    LCD_str(msg);                       //    \
    if(ck_SW())continue;                // SWŎIRM
// ------- Bitf[^̕\ ------------------------------
    LCD_posyx(0, 0);                    // i
    LCD_ROMstr("Bit No.     ");         //    ^Cg\
    LCD_posyx(0, 12);                   // iE[
    LCD_ROMstr("/ ");                   //    Bit\
    LCD_dec(numBits);
    i = 0;
    while(1){
        LCD_posyx(0, 7);
        LCD_dec(i+1);                   // Bitԍ\
        period = markBits[i]*10.6;      // MarkԂSɂ
        ito_st(period, msg, 6);         // ɕϊ
        LCD_posyx(1,0);                 // iɈړ
        LCD_str(msg);                   // \
        period = spaceBits[i]*10.6;     // SpaceԂSɂ
        ito_st(period, msg, 6);         // ɕϊ
        LCD_posyx(1,8);                 // iɈړ
        LCD_str(msg);                   // \
        if(++i >= numBits)i = 0;        // SBit\ȂBit0ɖ߂
        if(ck_SW())break;               // SŴ҂
    }                                   //    ŎIRM
    }
}
//****** PushSW͂mF *************************************** 
//  PushSW܂łɂƂǂ܂
//     Z  ߂l0
//       ߂l1 i700mSecȏj
//***************************************************************
char ck_SW(){
    while(PushSW);                      // SŴ҂
    WriteTimer0(0);                     // SWONԑJn
    T0IF = 0;
    Delay1KTCYx(60);                    // 5mS̃`^Oh~
    while(!PushSW && !T0IF);            // SW邩҂
    if(T0IF)return 1;                   // 699mSecȏȂ߂l1
    Delay1KTCYx(60);                    // 5mS̃`^Oh~
    return 0;                           // ZȂ       ߂l0
}
//****** 𕶎ɕϊ֐ *************************** 
//  num     ϊ鐮                  ([TvXj
//  strAdd  ϊʂ̊i[镶    (R}      j
//  digit   ϊ镶
//***************************************************************
void ito_st(unsigned long num, char *strAdd, char digit){
    char i;    
    char flag=1;                        //[TvX Flag
    char coma=0;                        //R} Flag    
    strAdd += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ʌ珈
        strAdd--;                       // P
        if (flag){                      // TvXłȂȂ
            if (coma++ == 3){           //    R}̈ʒuȂ
                *strAdd = ',';          //    R}i[
                coma=0;                 //    R}|C^Zbg
            }else{                      //    l𕶎ϊi[
                *strAdd =(num % 10) + 0x30;
                num = num / 10;         //    ̏
                if(num == 0) flag=0;    //    [Ȃȍ~̓TvX
            }
        }else{                          // TvXȂ
            *strAdd = 0x20;             //    Xy[Xi[
        }
    }
}
//****** 0-99̐𕶎ɂ\ ************************** 
//  num     ϊ鐮                  ([TvXj
//****************************************************************
void LCD_dec(char num){
    if (num / 10 == 0) LCD_dat(' ');    // \̈ʂ[Ȃ' '\
      else LCD_dat(num / 10 + 0x30);    // \̈ʂ̐\
    LCD_dat(num % 10 + 0x30);           // ̈ʂ̐\
}
//--- iwa ---
